---
title: List content types
slug: cms-13/api/list-content-types
docTags: 
createdAt: 2026-08-28T15:24:16.532Z
---

{
  "id": "FDm_nGofTBOCygYrGC8CD",
  "type": "api-oas-v2",
  "data": {
    "method": "GET",
    "url": "/_cms/v1/contenttypes",
    "servers": [
      {
        "url": "/_cms/v1/contenttypes",
        "description": "Optimizely CMS API"
      }
    ],
    "name": "List content types",
    "description": "List content types using the provided parameters.",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [
        {
          "kind": "optional",
          "name": "forContainerType",
          "type": "string",
          "description": "Only include types that are available for creation under the provided container type"
        },
        {
          "kind": "optional",
          "name": "sources",
          "type": "array",
          "description": "Indicates which sources should be included when listing content types. Use 'DEFAULT' to include content types without a specific source.",
          "schema": [],
          "itemType": "string",
          "customType": "string[]"
        },
        {
          "kind": "optional",
          "name": "pageIndex",
          "type": "integer<int32>",
          "description": "Zero based index of the page that should be retrieved.",
          "format": "int32",
          "minimum": 0,
          "maximum": 10000
        },
        {
          "kind": "optional",
          "name": "pageSize",
          "type": "integer<int32>",
          "description": "The maximum items per page that should be retrieved.",
          "format": "int32",
          "minimum": 1,
          "maximum": 10000
        }
      ],
      "bodyDataParameters": [],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "apiAuth",
          "name": "apiAuth",
          "kind": "optional",
          "type": "oauth2",
          "description": "Use this scheme to generate an access token that can be used to access the API.",
          "oauth2Flows": {
            "clientCredentials": {
              "tokenUrl": "/_cms/v1/oauth/token",
              "scopes": {
                "api:admin": "Grants full administrative access to the API"
              }
            }
          },
          "requiredScopes": [
            "api:admin"
          ]
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "OK",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>Represents a single page of items in a paged collection, including paging metadata such as the current page index, page size, and an estimated total item count.</p>",
            "customType": "ContentTypePage",
            "schema": [
              {
                "name": "items",
                "kind": "optional",
                "type": "array",
                "readOnly": true,
                "description": "The items in this paged collection.",
                "modelRef": "#/components/schemas/ContentType",
                "customType": "ContentType[]",
                "schema": [
                  {
                    "name": "key",
                    "kind": "optional",
                    "type": "string",
                    "description": "<p>The unique identifier (key) of the resource.</p>",
                    "minLength": 2,
                    "maxLength": 255,
                    "pattern": "^[A-Za-z][_0-9A-Za-z]+$"
                  },
                  {
                    "name": "displayName",
                    "kind": "required",
                    "type": "string",
                    "description": "The display name of this ContentType.",
                    "minLength": 1,
                    "maxLength": 255
                  },
                  {
                    "name": "description",
                    "kind": "optional",
                    "type": "string",
                    "description": "A description of this ContentType.",
                    "maxLength": 255
                  },
                  {
                    "name": "baseType",
                    "kind": "optional",
                    "type": "string",
                    "nullable": true,
                    "description": "<p>The base type of this ContentType. Ignored for contracts; required for all other content types.</p>"
                  },
                  {
                    "name": "isContract",
                    "kind": "optional",
                    "type": "boolean",
                    "description": "Specifies if the ContentType is a contract type."
                  },
                  {
                    "name": "source",
                    "kind": "optional",
                    "type": "string",
                    "readOnly": true,
                    "description": "A string that indicates the source of this content type. Can be used to distinguish content types created by the system from types coming from model classes in the CMS solution."
                  },
                  {
                    "name": "sortOrder",
                    "kind": "optional",
                    "type": "integer<int32>",
                    "description": "A value that is used to when sorting ContentType instances.",
                    "format": "int32"
                  },
                  {
                    "name": "mayContainTypes",
                    "kind": "optional",
                    "type": "array",
                    "description": "Provides a set of content types that can be created in containers of this type",
                    "example": "",
                    "itemType": "string",
                    "customType": "string[]",
                    "itemExample": "",
                    "itemDefault": ""
                  },
                  {
                    "name": "mediaFileExtensions",
                    "kind": "optional",
                    "type": "array",
                    "description": "Provides a set of media file extensions that this content type can handle.",
                    "example": "",
                    "itemType": "string",
                    "customType": "string[]",
                    "itemExample": "",
                    "itemDefault": ""
                  },
                  {
                    "name": "compositionBehaviors",
                    "kind": "optional",
                    "type": "array",
                    "description": "Provides a set of composition behaviors specifying how this content type can be used within compositions. Currently this can only be assigned when baseType is 'component'.",
                    "example": "",
                    "itemType": "string",
                    "customType": "string[]",
                    "itemExample": "",
                    "itemDefault": ""
                  },
                  {
                    "name": "contracts",
                    "kind": "optional",
                    "type": "array",
                    "description": "Provides a set of contract content types that this content type is bound to.",
                    "example": "",
                    "itemType": "string",
                    "customType": "string[]",
                    "itemExample": "",
                    "itemDefault": ""
                  },
                  {
                    "name": "created",
                    "kind": "optional",
                    "type": "string<date-time>",
                    "readOnly": true,
                    "description": "A timestamp indicating when this resource was first created.",
                    "format": "date-time"
                  },
                  {
                    "name": "createdBy",
                    "kind": "optional",
                    "type": "string",
                    "readOnly": true,
                    "description": "The name of the user or application that created this resource."
                  },
                  {
                    "name": "lastModified",
                    "kind": "optional",
                    "type": "string<date-time>",
                    "readOnly": true,
                    "description": "Indicates the last time this resource was modified.",
                    "format": "date-time"
                  },
                  {
                    "name": "lastModifiedBy",
                    "kind": "optional",
                    "type": "string",
                    "readOnly": true,
                    "description": "The name of the user or application that last modified this resource."
                  },
                  {
                    "name": "properties",
                    "kind": "optional",
                    "type": "map",
                    "description": "Dictionary with all custom properties of this ContentType.",
                    "example": "",
                    "customType": "map<string, ContentTypeProperty>",
                    "schema": []
                  },
                  {
                    "name": "accessRights",
                    "kind": "optional",
                    "type": "array",
                    "nullable": true,
                    "description": "<p>The access rights assigned to this content type that defines who can create content of this type. If no access rights are assigned, everyone will be able to create content of this type. An empty array means that no new content of this type can be created.</p>",
                    "modelRef": "#/components/schemas/SecurityIdentity",
                    "customType": "SecurityIdentity[]",
                    "schema": [
                      {
                        "name": "name",
                        "kind": "required",
                        "type": "string",
                        "description": "<p>The unique name of the user, role or application that this identifier references.</p>",
                        "minLength": 1,
                        "maxLength": 255
                      },
                      {
                        "name": "type",
                        "kind": "optional",
                        "type": "string<user | role | application>",
                        "description": "The type of the security entity that this identifier references. Will default to 'role' if not specified.",
                        "enum": [
                          "user",
                          "role",
                          "application"
                        ]
                      }
                    ]
                  }
                ]
              },
              {
                "name": "pageIndex",
                "kind": "optional",
                "type": "integer<int32>",
                "readOnly": true,
                "description": "<p>The zero-based index of the current page.</p>",
                "format": "int32"
              },
              {
                "name": "pageSize",
                "kind": "optional",
                "type": "integer<int32>",
                "readOnly": true,
                "description": "The number of items in each page. Not necessarily the same as the number of items in this page.",
                "format": "int32"
              },
              {
                "name": "totalCount",
                "kind": "optional",
                "type": "integer<int32>",
                "readOnly": true,
                "nullable": true,
                "description": "The estimated total number of items in the collection. May be omitted if the total count is unknown.",
                "format": "int32"
              }
            ],
            "modelRef": "#/components/schemas/ContentTypePage",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Unauthorized",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "403",
        "description": "Forbidden",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "500",
        "description": "Internal Server Error",
        "jsonExample": "",
        "isExpanded": true
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "wu1m6pzEeiFPOWnZhJUu8",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request GET \\\n     --url /_cms/v1/contenttypes \\\n     --header 'accept: application/json'"
        },
        {
          "id": "bnzPq2J_TbVsJwQztPWUH",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'GET',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"/_cms/v1/contenttypes\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "QfmFQgXHkyjwgQcyNaSvg",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"/_cms/v1/contenttypes\")\n\nhttp = Net::HTTP.new(url.host, url.port);\nrequest = Net::HTTP::Get.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = http.request(request)\nputs response.read_body\n"
        },
        {
          "id": "TMUXrr5nmiUGX5uAYAVgd",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"/_cms/v1/contenttypes\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"GET\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "wu1m6pzEeiFPOWnZhJUu8"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-200",
          "language": "200",
          "code": "// OK\n{\n  \"items\": [\n    {\n      \"key\": \"\",\n      \"displayName\": \"\",\n      \"description\": \"\",\n      \"baseType\": \"\",\n      \"isContract\": false,\n      \"source\": \"\",\n      \"sortOrder\": \"\",\n      \"mayContainTypes\": [\n        \"\"\n      ],\n      \"mediaFileExtensions\": [\n        \"\"\n      ],\n      \"compositionBehaviors\": [\n        \"\"\n      ],\n      \"contracts\": [\n        \"\"\n      ],\n      \"created\": \"\",\n      \"createdBy\": \"\",\n      \"lastModified\": \"\",\n      \"lastModifiedBy\": \"\",\n      \"properties\": \"\",\n      \"accessRights\": [\n        {\n          \"name\": \"\",\n          \"type\": \"\"\n        }\n      ]\n    }\n  ],\n  \"pageIndex\": \"\",\n  \"pageSize\": \"\",\n  \"totalCount\": \"\"\n}"
        },
        {
          "id": "response-1-401",
          "language": "401",
          "code": "// Unauthorized\n"
        },
        {
          "id": "response-2-403",
          "language": "403",
          "code": "// Forbidden\n"
        },
        {
          "id": "response-3-500",
          "language": "500",
          "code": "// Internal Server Error\n"
        }
      ],
      "selectedLanguageId": "response-0-200"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}